﻿Imports Modelo
Imports System.Data.entity

Public Class _Default
    Inherits System.Web.UI.Page
    Dim ctx As NorthwindEntities = New NorthwindEntities
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim cidade As String = "London"
        Dim cliente As String = "Comércio Mineiro"
        Dim codigoProduto As Integer = 15
        GridView1.DataSource = consultaDinamica("", cliente, codigoProduto)
        'GridView1.DataSource = consulta(10)
        GridView1.DataBind()
    End Sub
    Private Function consulta(ByVal valor As Double)
        Dim ctx As NorthwindEntities = New NorthwindEntities
        'Return ctx.Orders.Where(Function(o) o.ShipCity = cidade)
        'Return ctx.Orders.Where(Function(o) o.Customer.CompanyName = cliente)
        Return (ctx.Orders.Where(Function(o) o.Order_Details.Sum(Function(d) (d.UnitPrice * d.Quantity)) > valor))
    End Function
    Private Function consultaDinamica(ByVal cidade As String, ByVal cliente As String, ByVal codigoProduto As Integer)
        Dim resultado As IQueryable(Of Order) = ctx.Orders
        If Not String.IsNullOrEmpty(cidade) Then
            resultado = resultado.Where(Function(o) o.Order_Details.Any(Function(d) d.ProductID = codigoProduto))
        End If
        If Not String.IsNullOrEmpty(cliente) Then
            resultado = resultado.Where(Function(o) _
            o.Customer.CompanyName = cliente)
        End If
        Return resultado
    End Function
End Class